from django.test import TestCase
from web.forms import SubjectAddForm
from web.forms import VisitAddForm
from web.models import Subject
from web.models import Visit

from web.tests.functions import *

class SubjectAddFormTests(TestCase):
    def setUp(self):
        location = get_test_location()
        subject_data = {'first_name': 'name',
            'last_name': 'name',
            'sex' : Subject.SEX_CHOICES_MALE,
            'type' : Subject.SUBJECT_TYPE_CHOICES_CONTROL,
            'default_location' : location.id,
            'country' : 'Luxembourg',
        }
        self.subject = SubjectAddForm(data=subject_data).save()

        self.sample_data = {'datetime_begin': "2017-01-01",
            'datetime_end': "2017-02-02",
            'subject' : self.subject.id
        }

    def test_validation(self):
        form = VisitAddForm(data=self.sample_data)
        self.assertTrue(form.is_valid())

    def test_invalid_validation(self):
        self.sample_data['datetime_begin'] = "2017-02-02"
        self.sample_data['datetime_end'] = "2017-01-01"
        form = VisitAddForm(data=self.sample_data)
        validation_status = form.is_valid()
        self.assertFalse(validation_status)
        self.assertTrue("datetime_begin" in form.errors)
        self.assertTrue("datetime_end" in form.errors)
